function isNullStr(s) {
    if ((!s)||""==s||s==null||s==undefined||s=="undefined"){
        return true;
    }
    return false;
}

function isNullStrOr0(s) {
    if ((!s)||""==s||"0"==s||s==null||s==undefined||s=="undefined"){
        return true;
    }
    return false;
}

function nullToStr(s) {
    if ((!s)||s==null||s==undefined||s=="undefined"){
        return "";
    }
    return s;
}

function nullTo0(s) {
    if ((!s)||""==s||s==null||s==undefined||s=="undefined"){
        return "0";
    }
    return s;
}

function nullOr0toStr(s) {
    if ((!s)||s=="0"||s==null||s==undefined||s=="undefined"){
        return "";
    }
    return s;
}

function nulltoGang(s) {
    if ((!s)||s==""||s==null||s==undefined||s=="undefined"){
        return "-";
    }
    return s;
}

function userMedal(s) {
    if (isNullStrOr0(s)){
        return null;
    }
    var medal = "";
    var levelNumber= 0
    try {
        levelNumber = parseInt(s);
    } catch (e) {
        levelNumber = 0
    }
    if (levelNumber >= 1 && levelNumber <= 4) {
        medal = "yellow";
    } else if (levelNumber >= 5 && levelNumber <= 8) {
        medal = "green";
    } else if (levelNumber >= 9 && levelNumber <= 12) {
        medal = "blue";
    } else if (levelNumber >= 13) {
        medal = "red";
    }else{
        return null;
    }
    medal=bPicPath3x+"medal_right_"+medal+".png";
    return medal;
}

function userDLevel(s) {
    if (isNullStrOr0(s)){
        return null;
    }
    var levelNumber= 0;
    try {
        levelNumber = parseInt(s);
    } catch (e) {
        levelNumber = 0;
    }
    if(levelNumber<=0){
        //
    }else if(levelNumber>=6){
        return bPicPath3x+"d_level_m_6.png";
    }else{
        return bPicPath3x+"d_level_m_"+levelNumber+".png";
    }
    return null;
}

function hourAndMinute(d) {
    if (d.getMinutes()<10){
        return " "+d.getHours()+":"+"0"+d.getMinutes();
    }
    return " "+d.getHours()+":"+d.getMinutes();
}

function yearMonthAndDay(d) {
    return d.getFullYear()+"年"+ (d.getMonth()+1)+"月"+d.getDate()+"日";
}

function monthAndDay(d) {
    return (d.getMonth()+1)+"月"+d.getDate()+"日";
}

function monthAndDay1(d) {
    return (d.getMonth()+1)+"/"+d.getDate();
}
function monthAndDay2(d) {
    return (d.getMonth()+1)+"."+d.getDate()+"";
}

function onlyMonth0(d) {
    return (d.getMonth()+1)+"月";
}

function onlyDay0(d) {
    if (d.getDate()<10){
        return ("0"+d.getDate());
    }
    return ""+d.getDate();
}

function onlyWeek0(d) {
    var a = ["日", "一", "二", "三", "四", "五", "六"]
    return "周"+a[d.getDay()];
}

function weekAndDayAndMonth(params) {
    var array=new Array("-","-","-");
    if (isNullStrOr0(params)){
        return array
    }
    var lon=0;
    try {
        lon=parseInt(params);
    } catch (e) {
        return array;
    }
    if (params.length==10){
        lon=lon*1000;
    }
    var date=new Date(lon);
    try {
        array[0]=onlyDay0(date);
        array[1]=onlyWeek0(date);
        array[2]=onlyMonth0(date);
    } catch (e) {

    }
    return array;
}

function timeFormat1(s) {
    if(isNullStr(s)){
        return "";
    }
    var ms=1;
    if (s.length==10){
        ms=1000;
    }
    var targetDate= new Date(parseInt(s)*ms);
    return monthAndDay(targetDate);
}

function timeFormat(s) {
    if(isNullStr(s)){
        return "";
    }
    var currDate=new Date();
    var currentMiss=Date.parse(currDate);
    //毫秒 转换为 秒
    var currentLong=parseInt(currentMiss)/1000;
    //
    var targetLong=parseInt(s);
    var ms=1;
    if (s.length==10){
        ms=1000;
    }
    var targetDate= new Date(parseInt(s)*ms);
    var delta=0;
    if (currDate.toLocaleDateString()===targetDate.toLocaleDateString()){
        delta=currentLong-targetLong;
        //同一天（今天）
        if (delta < 60) {
            return "刚刚";
        }
        delta = parseInt(delta / 60);
        if (delta < 30) {
            return delta + "分钟前";
        }
        if (delta >= 30 && delta < 60) {
            return "半小时前";
        }
        delta = parseInt(delta / 60);
        if (delta < 24) {
            return delta + "小时前";
        }
        return "--";
    }else{
        //昨天，前天，几天前等
        delta = parseInt((currentLong - targetLong) / 60 / 60);
        if (delta < 48) {
            return "昨天" + hourAndMinute(targetDate);
        }
        if (delta < 72) {
            return "前天" + hourAndMinute(targetDate);
        }
        delta =parseInt(delta / 24);
        if (delta <= 7) {
            return delta + "天前" + hourAndMinute(targetDate);
        } else {
            if (targetDate.getFullYear() == currDate.getFullYear()) {
                return (targetDate.getMonth()+1) + "月" + targetDate.getDate() + "日" +hourAndMinute(targetDate);
            } else {
                return yearMonthAndDay(targetDate);
            }
        }
    }
    // return new Date(parseInt(s)*ms).toDateString();
    // return new Date(parseInt(s)*ms).toLocaleString();
    // return new Date(parseInt(s)*ms).toLocaleTimeString();
    // return new Date(parseInt(s)*ms).toLocaleDateString();
}

function forEmoji(str) {
    if (isNullStrOr0(str)){
        return str;
    }
    var params=null;
    //[emoji=1F62C=128556]
    // String.fromCodePoint(0x1F62C,0x1f602,0x1f603)
    //String.fromCodePoint(58386)
    var pattern=new RegExp("\\[emoji\\=(.*?)\\=(.*?)\\]","\g");
    var patternIn=new RegExp("\\=(.*?)\\=","\g");
    // var matchArray;
    // var num=1;
    // matchArray=pattern.exec(str);
    // while (matchArray){
    //     console.log("第"+num+" 个 index= "+ matchArray.index+" input= "+matchArray.);
    //     matchArray=pattern.exec(str);
    //     num++;
    // }
    var array=str.match(pattern);
    if (array){
        for(var k in array){
            try{
                params=array[k];
                params=params.match(patternIn).toString();
                params=params.substring(1,params.length-1);
                params="0x"+ params;
                params=String.fromCodePoint(params);
                // console.log("第"+k+" 个 index= "+ params);
                str=str.replace(array[k],params);
                // console.log("第"+k+" 个 replace = "+str);
            }catch (e) {
                continue;
            }
        }
    }
    patternIn=null;
    pattern=null;
    array=null;
    params=null;
    return str;
}

function ensureId(params,jsonObj) {
    if (jsonObj){
        params=jsonObj["type"];
        if ("top"==params){
            params=jsonObj["logid"];
        } else if ("find"==params){
            params=jsonObj["logid"];
        }else{
            params=jsonObj["id"];
        }
        return params;
    }
    return "-2000009"
}

function addMoreBtn(imgtype,type,num,eleAll) {
    if (num&&num!=null){
        var n=parseInt(num);
        if (n<=3){
            return;
        }
    }else{
        return;
    }
    if (eleAll){
        var params;
        switch (type) {
            case "评论":
                params="comtsmoe";
                break;
            case "晒单":
            case "爆料":
                params="sdismoe"+num;
                break;
            case "此刻":
                params="livsmoe";
                break;
            case "航线":
                params="hxsmoe";
                break;
            case "航线历史记录0":
                params="hxsmoe";
                num=null;
                type="";
                break;
            default:
                break;

        }
        params+="All";
        var divM=document.createElement("div");
        divM.setAttribute("class","morBtnAll");
        divM.setAttribute("id",params);
        //
        if (num&&num!=null){
            params="查看全部"+num+"条"+type;
        }else{
            params="查看全部"+type;
        }
        var desSpan=document.createElement("span");
        desSpan.innerText=params;
        //
        params=""
        switch (imgtype) {
            case "blue":
                params=bPicPath3x+"morebtn_right_img_blue.png";
                break;
            case "gray":
                params=bPicPath3x+"morebtn_right_img_black.png";
                break;
            default:
                break;

        }
        if (""!=params){
            var divImg=document.createElement("img");
            divImg.setAttribute("class", "morBtnImg");
            divImg.setAttribute("src", bgSrcGray);
            divImg.setAttribute("data-src", params);
            //
            divM.appendChild(desSpan);
            divM.appendChild(divImg);
        }else{
            divM.appendChild(desSpan);
        }
        var divDivider=document.createElement("div");
        divDivider.setAttribute("class","morBtnDivider");
        divM.appendChild(divDivider);
        eleAll.appendChild(divM);
    }
}

function addBottomMargin0(eleAll) {
    if (eleAll){
        var divDivider=document.createElement("div");
        divDivider.setAttribute("class","divider1012");
        eleAll.appendChild(divDivider);
    }
}

function assignParams(paramss) {
    communicationFunc("assignmentparams",paramss);
}

function parseEnd0(code) {
    communicationFunc("parseEnd0",code);
}

function isJsonArray(s) {
    if (s){
        //"[object Array]";
        var t=Object.prototype.toString.call(s);
        if ("[object Array]"==t){
            t=null;
            return true;
        }
    }
    return false;
}
