/*
* id=loadmoreid
* */
var lmid="loadmoreid";
var isloading=false;
var fininshTime=0;
//
/*0：失败或者未定义
* 1：成功，且有数据
* 2：成功，但是没有数据（即，没有更多）
* */
var LM_Status ={fail:0,succ:1,noMore:2};
LM_Status=Object.freeze(LM_Status);
//
var loadMoreStatus=0;

//
/* 比如"懒人包"，只需要，在底部添加"加载中。。。"，而api请求在android里面完成*/
var noNeedLoadMoreHttp=false;

function addLoadMoreView(parentId) {
    if (!isloading){
        if (fininshTime!=0){
            var currDate=new Date();
            var currTime=Date.parse(currDate);
            if ((currTime-fininshTime)<1000){
                console.log("触发 连续 加载 ，不执行")
                return;
            }
        }
        var eleParent=document.getElementById(parentId);
        if (eleParent){
            var loadMoreEle=document.getElementById(lmid);
            if (loadMoreEle){
                console.log(" 已经添加load view "+isloading);
                var progressEle=document.getElementById("loader1015In");
                var loadOverEle=document.getElementById("loadMoreOver1015");
                var noMoreEle=document.getElementById("noMoreData1015");
                if (progressEle){
                    console.log(" 动画仍然在执行中 "+isloading);
                    isloading=true;
                }else if (loadOverEle){
                    console.log(" 显示 load view 显示空白 占位 "+isloading);
                    setLoadProgress(loadMoreEle);
                    isloading=true;
                }else if (noMoreEle){
                    console.log(" 显示 没有更多 数据 "+isloading);
                    //
                    //
                }
            }else{
                loadMoreEle=document.createElement("div");
                loadMoreEle.setAttribute("id",lmid);
                loadMoreEle.setAttribute("class","loader1015");
                setLoadProgress(loadMoreEle);
                eleParent.appendChild(loadMoreEle);
                isloading=true;
                console.log("第一次添加 load view "+isloading);
                if (noNeedLoadMoreHttp){
                    /*某些页面，底部加载更多，不需要在js里面做http请求，比如"懒人包"*/
                    httpRequestByJava();
                }else{
                    httpRequestStart(httpUrl);
                }
            }
        }
    }
}

function finishLoadMore(parentId) {
    var loadMoreEle=document.getElementById(lmid);
    if (loadMoreEle){
        switch (loadMoreStatus) {
            case 0 :
                //failed,或者"未定义"
                console.log(" finish failed");
                setLoadOver(loadMoreEle);
                break;
            case 1 :
                //成功，且有数据
                console.log(" finish 成功，且有数据");
                var eleP=document.getElementById(parentId);
                if (eleP){
                    eleP.removeChild(loadMoreEle);
                    isloading=false;
                    var currDate=new Date();
                    fininshTime=Date.parse(currDate);
                    console.log(" finish remove ");
                }
                break;
            case 2 :
                //成功，且没有数据（没有更多数据）
                console.log(" finish 没有更多数据");
                setNoLoadMore(loadMoreEle);
                break;
            default:
                break;

        }
    }
}

/*开始加载下一页，显示转动动画*/
function setLoadProgress(ele) {
    if (ele){
        ele.innerHTML="<div class=\"loader1015In\">" +
            "<svg version=\"1.1\" id=\"svg1015\"  x=\"0px\" y=\"0px\" width=\"100px\" height=\"100px\" viewBox=\"0 0 50 50\" style=\"enable-background:new 0 0 50 50;\" xml:space=\"preserve\">" +
            "<path fill=\"#000\" d=\"M43.935,25.145c0-10.318-8.364-18.683-18.683-18.683c-10.318,0-18.683,8.365-18.683,18.683h4.068c0-8.071,6.543-14.615,14.615-14.615c8.072,0,14.615,6.543,14.615,14.615H43.935z\">" +
            "<animateTransform attributeType=\"xml\" attributeName=\"transform\" type=\"rotate\" from=\"0 25 25\" to=\"360 25 25\" dur=\"0.6s\" repeatCount=\"indefinite\" />" +
            "</path>"+
            "</svg>" +
            "<div class=\"loadmsg1015\">正在加载...</div>" +
            "</div>";
    }
    isloading=true;
}

/*加载下一页完成之后：显示空白*/
function setLoadOver(ele) {
    if (ele){
        ele.innerHTML="<div id='loadMoreOver1015'></div>";
    }
    isloading=false;
}

/*加载下一页完成之后：显示"没有更多了～"*/
function setNoLoadMore(ele) {
    if (ele){
        ele.innerHTML="<div id='noMoreData1015'>没有更多了～</div>";
    }
}
function resetNoNeedLoadMoreHttp(status) {
    noNeedLoadMoreHttp=status;
}

/*根据请求结果，判断加载是否成功，确定status的值*/
function resetLoadMoreStatus(status) {
    loadMoreStatus=status;
}

/*第一种数据类型*/
function ensureLoadMoreResult0(obj,listTag) {
    console.log(" ensure load more result ");
    if(obj!=null&&obj){
        var msgObj=obj["msg"];
        if (typeof msgObj == 'string'){
            console.log(" load more : msgObj = string /fail");
            resetLoadMoreStatus(LM_Status.fail);
            msgObj=null;
        }else{
            var array=msgObj[listTag];
            msgObj=null;
            if (!array){
                console.log(" load more : array not exist /noMore");
                resetLoadMoreStatus(LM_Status.noMore);
                return;
            }
            if (array!=null&&array.length>0){
                console.log(" load more : successful ");
                resetLoadMoreStatus(LM_Status.succ);
            }else{
                console.log(" load more : noMore ");
                resetLoadMoreStatus(LM_Status.noMore);
            }
            array=null;
        }
    }else{
        console.log(" load more : fail");
        resetLoadMoreStatus(LM_Status.fail);
    }
}